﻿precision mediump float;
varying vec2 vUV;
uniform vec4 uColor;
uniform sampler2D sTexture;

const vec2 center = vec2(0.5,0.5);
const float angle = 1.57;
const float scale = 1.0;

vec2 tSize;

float pattern()
{
	float s = sin( angle ), c = cos( angle );
	vec2 tex = vUV * tSize - center;
	vec2 point = vec2( c * tex.x - s * tex.y, s * tex.x + c * tex.y ) * scale;
	return ( sin( point.x ) * sin( point.y ) ) * 4.0;
}

void main()
{
	float size = 128.0;
	tSize = vec2( size, size );
	vec4 color = texture2D( sTexture, vUV );
    float p = pattern();
    gl_FragColor = vec4(color.r * 10.0 - 5.0 + p , color.g * 10.0 - 5.0 + p ,color.b * 10.0 - 5.0 + p , color.a ) * uColor;
}
