﻿precision mediump float;
varying vec2 vUV;
uniform vec4 uColor;
uniform sampler2D sTexture;
uniform vec2 uMaxUV;

const float sides = 6.0;
const float angle = 0.0;

float unitVal(float src)
{
    if (src >= 1.0)
	    return min(2.0 - src, 0.99);

    return abs(src);
}

vec2 KaleidoscopeIt(vec2 uv)
{
    vec2 unitUV = uv / uMaxUV;

//    vec2 p = uv - 0.5;
    vec2 p = unitUV - 0.5;
    float r = length(p);
    float a = atan(p.y, p.x) + angle;
    float tau = 2. * 3.1416;
    a = mod(a, tau/sides);
    a = abs(a - tau/sides/2.);
    p = r * vec2(cos(a), sin(a));

//    return p + 0.5;
    p = p + 0.5;
    p.x = unitVal(p.x);
    p.y = unitVal(p.y);
    
    return p * uMaxUV;
}

void main()
{
	vec2 newUV = KaleidoscopeIt(vUV);
	gl_FragColor = texture2D(sTexture, newUV) * uColor;	
}
